%
%   assembly_base.m  ver 1.0  August 24, 2012
%
function[stiff,mass,dof_status]=...
                 assembly_base(ne,klocal,mlocal,ipin,dof,ipm,pm,xpm,dx)
%
    dof_status=ones(dof,1);
%
    for i=1:dof
			for j=1:dof
         		 sg(i,j)=0.;
				 mg(i,j)=0.;        
             end
    end
%
   ii=0;
   jj=0;
    for k=1:ne
        for i=1:4
			for j=1:4
				 sg(ii+i,jj+j)=sg(ii+i,jj+j)+klocal(k,i,j);
				 mg(ii+i,jj+j)=mg(ii+i,jj+j)+mlocal(k,i,j);
             end
        end
        ii=ii+2;
        jj=jj+2;
    end
%%%%
%%%%   Add point mass
%%%%
if (ipm==1)
    nnn=0;
    xv(1)=0.;
    for i=2:dof/2
        xv(i)=xv(i-1)+dx(i-1);
    end
    for i=1:dof/2
        if(xv(i)==xpm)
            nnn=i;
            break;
        end
    end
end
if (ipm==1)
    i=nnn;
    2*i-1;
    mg(2*i-1,2*i-1)=mg(2*i-1,2*i-1)+pm;
end
%%%%
%%%%    Apply bc
%%%%
%%
%%%% disp('  Constrain rotational dof ');
%%%% disp('  1=none '); 
%%%% disp('  2=left end only ');
%%%% disp('  3=left & right ends  ');
%
clear mass;
clear stiff;
%
stiff=sg;
mass=mg;
%
N=max(size(mass));
%
if(ipin==1) % free-free 
%
%  no bcs applied
%
end
%
if(ipin==2) % left end only constrained 
%
     stiff(2,:)=[];
     stiff(:,2)=[];
%
     mass(2,:)=[];
     mass(:,2)=[];
%
     dof_status(2)=0; 
%
end
%
if(ipin==3) % left & right ends constrained
%
     stiff(N,:)=[];
     stiff(:,N)=[];
     mass(N,:)=[];
     mass(:,N)=[];
%
     stiff(2,:)=[];
     stiff(:,2)=[];
%
     mass(2,:)=[];
     mass(:,2)=[];
%
     dof_status(N)=0;
     dof_status(2)=0; 
%
end
%
dof=max(size(mass));
%